const ora = require('ora')
const inquirer = require('inquirer')
const chalk = require('chalk')
const util = require('util')
const path = require('path')
// const downloadGitRepo = require('download-git-repo') // 不支持 Promise
// const download = require('./gitdownload') // 不支持 Promise
const gitDownload = require("gitstore-d")
// console.log(download)
// 添加加载动画
async function wrapLoading(fn, message, ...args) {
  // 使用 ora 初始化，传入提示信息 message
  const spinner = ora(message);
  // 开始加载动画
  spinner.start();

  try {
  // 执行传入方法 fn
  const result = await fn(...args);
  // 状态为修改为成功Place choose a tag to create project
  spinner.succeed('哎哟，不错哦！');
  return result;
  } catch (error) {
  // 状态为修改为失败
  spinner.fail('嗯哼？？？', error)
  }
}

class Generator {
  constructor(name, targetDir) {
    // 目录名称
    this.name = name;
    // 创建位置
    this.targetDir = targetDir;
    // 对 download-git-repo 进行 promise 化改造
    this.downloadGitRepo = gitDownload;
    // this.downloadGitRepo = util.promisify(download);

  }
  // 下载远程模板
  // 1）拼接下载地址
  // 2）调用下载方法
  async download(repo, tag) {

    // 1）拼接下载地址
    // const requestUrl = `vuejs/${repo}${tag ? '#' + tag : ''}`;
    // const requestUrl = "zhangxin1001/xinui-vue#main";
    // const requestUrl = "vuejs/vue#v2.6.14"
    // const requestUrl = "gitee:zxwaa/vue_object_template#master"
    // const requestUrl = "gitee:zxwaa/eggjs_study#master"
    // const requestUrl = "gitee:zxwaa/test#v0.2"
    const requestUrl = `gitee:zxwaa/test#${tag}`


    // console.log(requestUrl)
    // 2）调用下载方法
    await wrapLoading(
      this.downloadGitRepo, // 远程下载方法
      '大佬，请稍等片刻', // 加载提示信息
      // requestUrl, // 参数1: 下载地址
      tag,
      path.resolve(process.cwd(), this.targetDir), // 参数2: 创建位置
      { clone: true }
    )
    // let res = await this.downloadGitRepo(requestUrl, path.resolve(process.cwd(), this.targetDir), { clone: true })
    // console.log(res)
  }

  // 获取用户选择的模板
  // 1）从远程拉取模板数据
  // 2）用户选择自己新下载的模板名称
  // 3）return 用户选择的名称

  async getRepo() {
    // 1）从远程拉取模板数据
    const repoList = await wrapLoading(getRepoList, '正在等待获取模板');
    // console.log(repoList)
    if (!repoList) return;
    // 这个时间可以考虑，来杯咖啡
    // 过滤我们需要的模板名称
    const repos = repoList.map(item => item.name);

    // 2）用户选择自己新下载的模板名称
    const {
      repo
    } = await inquirer.prompt({
      name: 'repo',
      type: 'list',
      choices: repos,
      message: '选择总是困难的'
    })

    // 3）return 用户选择的名称
    return repo;
  }

  // 获取用户选择的版本
  // 1）基于 repo 结果，远程拉取对应的 tag 列表
  // 2）用户选择自己需要下载的 tag
  // 3）return 用户选择的 tag

  async getTag(repo) {
    // 1）基于 repo 结果，远程拉取对应的 tag 列表
    // const tags = await wrapLoading(getTagList, '等待获取标记', repo);
    // if (!tags) return;

    // 过滤我们需要的 tag 名称
    // const tagsList = tags.map(item => item.name);
    // console.log(tags)

    // 2）用户选择自己需要下载的 tag
    const {
      tag
    } = await inquirer.prompt({
      name: 'tag',
      type: 'list',
      choices: [
        {name:"vue2",value:"gitee:zxwaa/vue_object_template"},
        {name:"react",value:"gitee:zxwaa/react_template"},
      ],
      message: '选择要创建的项目模板：'
    })
// console.log(tag)
    // 3）return 用户选择的 tag
    return tag
  }

  // 核心创建逻辑
  // 1）获取模板名称
  // 2）获取 tag 名称
  // 3）下载模板到模板目录
  async created() {

    // 1）获取模板名称
    // const repo = await this.getRepo();

    // 2) 获取 tag 名称
    // const tag = await this.getTag(repo);
    const tag = await this.getTag();

    // 3）下载模板到模板目录
    // await this.download(repo, tag);
    await this.download(1, tag);

    // await this.download();


    console.log(`\r\n您已成功创建了项目： ${chalk.cyan(this.name)}`)
    console.log(`\r\n${chalk.cyan('   cd ' + this.name)}`)
    console.log(`\r${chalk.cyan('   yarn')}`)
    console.log(`\r${chalk.cyan('   yarn start')}`)
  }
}

module.exports = Generator;